Index: net/if.c
===================================================================
--- net/if.c	(revision 248707)
+++ net/if.c	(working copy)
@@ -1532,6 +1532,8 @@
 
 	IFNET_RLOCK_NOSLEEP();
 	TAILQ_FOREACH(ifp, &V_ifnet, if_link) {
+		if ((ifp->if_flags & IFF_UP) == 0)
+			continue;
 		IF_ADDR_RLOCK(ifp);
 		TAILQ_FOREACH(ifa, &ifp->if_addrhead, ifa_link) {
 			if (ifa->ifa_addr->sa_family != addr->sa_family)
@@ -1620,6 +1622,8 @@
 
 	IFNET_RLOCK_NOSLEEP();
 	TAILQ_FOREACH(ifp, &V_ifnet, if_link) {
+		if ((ifp->if_flags & IFF_UP) == 0)
+			continue;
 		if ((ifp->if_flags & IFF_POINTOPOINT) == 0)
 			continue;
 		IF_ADDR_RLOCK(ifp);
@@ -1672,6 +1676,8 @@
 	 */
 	IFNET_RLOCK_NOSLEEP();
 	TAILQ_FOREACH(ifp, &V_ifnet, if_link) {
+		if ((ifp->if_flags & IFF_UP) == 0)
+			continue;
 		IF_ADDR_RLOCK(ifp);
 		TAILQ_FOREACH(ifa, &ifp->if_addrhead, ifa_link) {
 			char *cp, *cp2, *cp3;
Index: net/if_ethersubr.c
===================================================================
--- net/if_ethersubr.c	(revision 248707)
+++ net/if_ethersubr.c	(working copy)
@@ -812,6 +871,11 @@
 #if defined(NETATALK)
 	struct llc *l;
 #endif
+	/* Discard packet if interface is not up */
+	if ((ifp->if_flags & IFF_UP) == 0) {
+		m_freem(m);
+		return;
+	}
 
 	KASSERT(ifp != NULL, ("%s: NULL interface pointer", __func__));
 
